#!/bin/sh

# Slackware build script for libtorrent
# Written by Tom Fitzhenry <tom@fitzhenry.name> 2007/08/22
# Updated by Andrew Brouwers, abrouwers@gmail.com
# Updated by Exaga sarpi.team@penthux.net - 2025-12-14

SLACKVER=$(grep "VERSION_CODENAME" /etc/os-release | cut -d'=' -f2)
if [ "$SLACKVER" = "stable" ]; then
    SLACKVER="15.0"
else
    SLACKVER="current"
fi

PRGNAM=libtorrent
VERSION=${VERSION:-0.16.7}
BUILD=${BUILD:-1}
TAG="${TAG:-_slack${SLACKVER}_sp1}"
PKGTYPE="${PKGTYPE:-txz}"

if [ -z "$ARCH" ]; then
  case "$( uname -m )" in
    i?86) export ARCH=i486 ;;
	aarch64) export ARCH=aarch64 ;;
    arm*) export ARCH=arm ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
       *) export ARCH=$( uname -m ) ;;
  esac
fi

CWD=$(pwd)
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
LIBTORRTENT_REPO_URL="https://github.com/rakshasa/libtorrent/"

if [ "$ARCH" = "i586" ]; then
  SLKCFLAGS="-O2 -march=i586 -mtune=i686"
  LIBDIRSUFFIX=""
elif [ "$ARCH" = "i686" ]; then
  SLKCFLAGS="-O2 -march=i686 -mtune=i686"
  LIBDIRSUFFIX=""
elif [ "$ARCH" = "x86_64" ]; then
  SLKCFLAGS="-O2 -fPIC"
  LIBDIRSUFFIX="64"
elif [ "$ARCH" = "aarch64" ]; then
  SLKCFLAGS="-O2 -fPIC"
  LIBDIRSUFFIX="64"
else
  SLKCFLAGS="-O2"
  LIBDIRSUFFIX=""
fi

set -e

rm -rf "$PKG"
mkdir -p "$TMP" "$PKG" "$OUTPUT"
rm -rf "$TMP/$PRGNAM-$VERSION"
cd "$TMP"

git clone "${LIBTORRTENT_REPO_URL}" "${TMP}/${PRGNAM}-${VERSION}"
cd "$TMP/$PRGNAM-$VERSION"

chown -R root:root .
find -L . \
 \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
  -o -perm 511 \) -exec chmod 755 {} \; -o \
 \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
  -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;

autoreconf -ivf
./configure

CFLAGS="$SLKCFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
./configure \
  --prefix=/usr \
  --libdir=/usr/lib${LIBDIRSUFFIX} \
  --sysconfdir=/etc \
  --localstatedir=/var \
  --with-posix-fallocate \
  --build=$ARCH-slackware-linux

make -j$(nproc)
make install DESTDIR=$PKG

mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a AUTHORS COPYING INSTALL README.md $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc/$PRGNAM-$VERSION -type f -exec chmod 644 {} \;
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM-SlackBuild

find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc

cd $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-${ARCH}v7-$BUILD$TAG.${PKGTYPE:-txz}
cd $OUTPUT
/bin/md5sum $PRGNAM-$VERSION-${ARCH}v7-$BUILD$TAG.${PKGTYPE:-txz} > $OUTPUT/$PRGNAM-$VERSION-${ARCH}v7-$BUILD$TAG.md5

exit 0

# EOF<*>
